// $Id: udpcat.cc 56 2009-05-13 13:33:24Z g0dil $
//
// Copyright (C) 2009 
// Fraunhofer Institute for Open Communication Systems (FOKUS)
// Competence Center NETwork research (NET), St. Augustin, GERMANY
//     Stefan Bund <g0dil@berlios.de>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the
// Free Software Foundation, Inc.,
// 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

/** \file
    \brief udpcat non-inline non-template implementation */

//#include "udpcat.hh"
//#include "udpcat.ih"

// Custom includes
#include <senf/Socket/Protocols/INet/UDPSocketHandle.hh>

//#include "udpcat.mpp"
#define prefix_
///////////////////////////////cc.p////////////////////////////////////////

void udpIn(senf::INet4SocketAddress addr)
{
    senf::UDPv4ClientSocketHandle handle (addr);
    for (;;)
        std::cout << handle.read() << std::flush;
}

void udpOut(senf::INet4SocketAddress addr)
{
    senf::UDPv4ClientSocketHandle handle;
    std::string line;
    while (getline(std::cin, line)) {
        line += "\n";
        handle.writeto(addr, line);
    }
}

int main(int argc, char ** argv)
{
    switch (argc) {
    case 2:
        udpIn(senf::INet4SocketAddress(boost::lexical_cast<unsigned>(std::string(argv[1]))));
        break;
    case 3:
        udpOut(senf::INet4SocketAddress(senf::INet4Address::from_string(argv[1]),
                                        boost::lexical_cast<unsigned>(std::string(argv[2]))));
        break;
    default:
        std::cerr << "Usage:\n" "    udpcat ip port\n" "    udpcat port\n" << std::flush;
        break;
    }
    return 1;
}

///////////////////////////////cc.e////////////////////////////////////////
#undef prefix_
//#include "udpcat.mpp"


// Local Variables:
// mode: c++
// fill-column: 100
// comment-column: 40
// c-file-style: "senf"
// indent-tabs-mode: nil
// ispell-local-dictionary: "american"
// compile-command: "scons -u"
// End:
